#include "Clock.h"
#include <StringView.h>
#include <stdlib.h>
#include <View.h>
#include <Screen.h>
#include <stdio.h>
#include <time.h>

// MAIN INSTANTIATION FUNCTION
extern "C" _EXPORT BScreenSaver *instantiate_screen_saver(BMessage *message, image_id image)
{
	return new Clock(message, image);
}

Clock::Clock(BMessage *message, image_id image)
 : BScreenSaver(message, image)
{
}

void Clock::StartConfig(BView *view)
{
	tview = new BStringView(BRect(10, 10, 200, 35), B_EMPTY_STRING, "Clock Saver");
	tview->SetFont(be_bold_font);
	tview->SetFontSize(15);
	view->AddChild(tview);
	view->AddChild(new BStringView(BRect(20, 35, 200, 50), B_EMPTY_STRING, "   Ver. 1.1.0 / May, 4,2000 (C)Tarcus"));
	view->AddChild(new BStringView(BRect(20, 50, 200, 75), B_EMPTY_STRING, "WinBe (Sorry! Japanese version Only)"));
	view->AddChild(new BStringView(BRect(30, 80, 200, 100), B_EMPTY_STRING, "http://menber.nifty.ne.jp/tarucus/"));
	view->AddChild(new BStringView(BRect(30, 100, 200, 120), B_EMPTY_STRING, "       be/beos.htm"));
}

status_t Clock::StartSaver(BView *view, bool preview /* preview */)
{
	float f;
	font_height height;
	
		SetTickSize(500000);

		view->SetHighColor(255,255,255);
		view->SetLowColor(0,0,0);

		r = view->Bounds();
		view->FillRect(r, B_SOLID_LOW);
		view->SetFont(be_bold_font);
		if (preview) view->SetFontSize(10);
		else  view->SetFontSize(24);
		view->GetFont(&font);
		fontsize = font.Size();

		f = font.StringWidth("2000/01/01 00:00:00");
		w = int (f);
		font.GetHeight(&height);
		f = height.ascent + height.descent + height.leading + 1;
		h = int(f);

		x = 0;
		y = h;
		dx = w / 4;
		dy = h;
		view->MovePenTo(0, h);
	return B_OK;
}

void Clock::Draw(BView *view, int32)
{
	time(&tmptodaytime);
	TodayTime = localtime(&tmptodaytime);

	todaysecond = TodayTime->tm_sec;
	todayminute = TodayTime->tm_min;
	todayhour   = TodayTime->tm_hour;
	todayday    = TodayTime->tm_mday;
	todaymonth  = TodayTime->tm_mon;
	todayyear   = TodayTime->tm_year;
	
	todayyear = todayyear + 1900;

	sprintf(call ,"%04d/%02d/%02d %02d:%02d:%02d", todayyear, todaymonth + 1, todayday, todayhour, todayminute, todaysecond);
		view->FillRect(r, B_SOLID_LOW);
		view->DrawString(call);

	if (dx > 0)
		if ((x + 5 * dx) > r.right) dx = -dx;

	if (dx < 0)
		if ((x + dx ) < r.left) dx = -dx;

	if (dy > 0)
		if ((y + dy) > r.bottom) dy = -dy;

	if (dy < 0)
		if ((y + dy) < r.top + h) dy = -dy;

	x = x + dx;
	y = y + dy;
	view->MovePenTo(x, y);
}